// [!output DIALOG_IMPL] : implementation file
//

#include "stdafx.h"
#include "[!output APP_HEADER]"
#include "[!output DIALOG_HEADER]"
[!if AUTOMATION]
#include "[!output DIALOG_AUTO_PROXY_HEADER]"
[!endif]

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

[!if ABOUT_BOX]

// CAboutDlg dialog used for App About
class CAboutDlg : public CExtNCW < CExtResizableDialog >
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	CExtButton	m_BtnOK;

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	virtual BOOL OnInitDialog();
	DECLARE_MESSAGE_MAP()
};


CAboutDlg::CAboutDlg() : CExtNCW < CExtResizableDialog >(CAboutDlg::IDD)
{
[!if ACCESSIBILITY]
	EnableActiveAccessibility();
[!endif]
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDOK, m_BtnOK);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CExtResizableDialog)
END_MESSAGE_MAP()


BOOL CAboutDlg::OnInitDialog()
{
	VERIFY( CExtNCW < CExtResizableDialog >::OnInitDialog() );

[!if VERBOSE]
	//
	// Show size gripper
	//
[!endif]
	CExtNCW < CExtResizableDialog >::ShowSizeGrip( FALSE );

[!if VERBOSE]
	//
	// Enable dialog position saving/restoring in registry
	//
[!endif]
[!if PUIS_SROPTIONS_DIAlOGPOSITION]
	CExtNCW < CExtResizableDialog >::EnableSaveRestore(
		__PROF_UIS_PROJECT_DLG_PERSIST_REG_KEY,
		_T("CAboutDlg-Saved-Position")
		);

[!endif]
	// TODO: Add extra initialization here
	return TRUE;  // return TRUE  unless you set the focus to a control
}
[!endif]

// [!output DIALOG_CLASS] dialog

[!if HTML_DIALOG]
BEGIN_DHTML_EVENT_MAP([!output DIALOG_CLASS])
	DHTML_EVENT_ONCLICK(_T("ButtonOK"), OnButtonOK)
	DHTML_EVENT_ONCLICK(_T("ButtonCancel"), OnButtonCancel)
[!if CONTEXT_HELP]
	DHTML_EVENT_ONCLICK(_T("ButtonHelp"), OnButtonHelp)
[!endif]
END_DHTML_EVENT_MAP()
[!endif]


[!if AUTOMATION]

IMPLEMENT_DYNAMIC([!output DIALOG_CLASS], CExtResizableDialog);
[!endif] 

[!output DIALOG_CLASS]::[!output DIALOG_CLASS](CWnd* pParent /*=NULL*/)
[!if HTML_DIALOG]
	: CDHtmlDialog([!output DIALOG_CLASS]::IDD, [!output DIALOG_CLASS]::IDH, pParent)
[!else]
	: CExtNCW < CExtResizableDialog >([!output DIALOG_CLASS]::IDD, pParent)
[!endif]
{
[!if ACCESSIBILITY]
	EnableActiveAccessibility();
[!endif]
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
[!if AUTOMATION]
	m_pAutoProxy = NULL;
[!endif]
}
[!if AUTOMATION]

[!output DIALOG_CLASS]::~[!output DIALOG_CLASS]()
{
	// If there is an automation proxy for this dialog, set
	//  its back pointer to this dialog to NULL, so it knows
	//  the dialog has been deleted.
	if (m_pAutoProxy != NULL)
		m_pAutoProxy->m_pDialog = NULL;
}
[!endif]

void [!output DIALOG_CLASS]::DoDataExchange(CDataExchange* pDX)
{
	CExtNCW < CExtResizableDialog >::DoDataExchange(pDX);


	DDX_Control(pDX, IDOK, m_BtnOK);
	DDX_Control(pDX, IDCANCEL, m_BtnCancel);
[!if CONTEXT_HELP]
	DDX_Control(pDX, ID_HELP, m_BtnHelp);
[!endif]

}

BEGIN_MESSAGE_MAP([!output DIALOG_CLASS], CExtResizableDialog)
[!if ABOUT_BOX]
	ON_COMMAND( ID_APP_ABOUT, OnAbout )
[!endif]
[!if CONTEXT_HELP && HELPSTYLE_WINHELP && PUIS_SROPTIONS_COMMANDUSAGE]
	ON_WM_DESTROY()
[!endif]
[!if AUTOMATION]
	ON_WM_CLOSE()
[!endif]
[!if !HTML_DIALOG]
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
[!endif]
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// [!output DIALOG_CLASS] message handlers

BOOL [!output DIALOG_CLASS]::OnInitDialog()
{
	CExtNCW < CExtResizableDialog >::OnInitDialog();
        
[!if ABOUT_BOX]
	CString strAboutMenu;
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (	pSysMenu != NULL &&
		strAboutMenu.LoadString(IDS_ABOUTBOX))
	{
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, ID_APP_ABOUT, strAboutMenu);
		}
	}
[!endif]

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

[!if MAIN_FRAME_MAXIMIZED]
	ShowWindow(SW_MAXIMIZE);

[!endif]
[!if MAIN_FRAME_MINIMIZED]
	ShowWindow(SW_MINIMIZE);

[!endif]
	// TODO: Add extra initialization here


[!if VERBOSE]
	//
	// Setup anchors for resizable dialog controls
    //
[!endif] //VER]BOSE
	CExtNCW < CExtResizableDialog >::AddAnchor( IDOK, __RDA_RT );
	CExtNCW < CExtResizableDialog >::AddAnchor( IDCANCEL, __RDA_RT );
[!if CONTEXT_HELP]
	CExtNCW < CExtResizableDialog >::AddAnchor( ID_HELP, __RDA_RT );
[!endif]

[!if PUIS_SROPTIONS_DIALOGPOSITION]
[!if VERBOSE]
	//
	// Enable dialog position saving/restoring in registry
	//
[!endif] //VERBOSE
	CExtNCW < CExtResizableDialog >::EnableSaveRestore(
		__PROF_UIS_PROJECT_DLG_PERSIST_REG_KEY,
		_T("[!output DIALOG_CLASS]-Saved-Position")
		);

[!else] //!__PROFUISAPPWIZ_KEY_PERS_POS_DLG
[!if VERBOSE]
	//
	// Uncomment these lines to enable dialog position
	// saving/restoring in registry
	//
[!endif] //VERBOSE
	//CExtNCW < CExtResizableDialog >::EnableSaveRestore(
	//	__PROF_UIS_PROJECT_DLG_PERSIST_REG_KEY,
	//	_T("[!output DIALOG_CLASS]-Saved-Position")
	//	);

[!endif] //!__PROFUISAPPWIZ_KEY_PERS_POS_DLG
[!if VERBOSE]
	//
	// Show size gripper
    	//
[!endif] //VERBOSE
	CExtNCW < CExtResizableDialog >::ShowSizeGrip( TRUE );

[!if PUIS_SROPTIONS_COMMANDUSAGE]
[!if VERBOSE]
	//
	// Attach this window to Prof-UIS command manager profile
	//
[!endif]
	CWinApp * pApp = ::AfxGetApp();
	ASSERT( pApp != NULL );
	ASSERT( pApp->m_pszRegistryKey != NULL );
	ASSERT( pApp->m_pszRegistryKey[0] != _T('\0') );
	ASSERT( pApp->m_pszProfileName != NULL );
	ASSERT( pApp->m_pszProfileName[0] != _T('\0') );
	VERIFY(
		g_CmdManager->ProfileWndAdd (
			__PROF_UIS_PROJECT_CMD_PROFILE_NAME,
			GetSafeHwnd()
			)
		);

[!if ABOUT_BOX]
[!if VERBOSE]
	//
	// Register ID_APP_ABOUT command
	//
[!endif]
CExtCmdManager::cmd_t _cmd( ID_APP_ABOUT );
	_cmd.m_sMenuText = strAboutMenu;
	VERIFY(
		g_CmdManager->CmdSetup(
			__PROF_UIS_PROJECT_CMD_PROFILE_NAME,
			_cmd
			)
		);
[!endif]

[!if VERBOSE]
	//
	// Load command usage statistics
	//
[!endif]
	g_CmdManager->SerializeState(
		__PROF_UIS_PROJECT_CMD_PROFILE_NAME,
		pApp->m_pszRegistryKey,
		pApp->m_pszProfileName,
		false
		);
	
[!endif]

	return TRUE;  // return TRUE  unless you set the focus to a control
}
[!if ABOUT_BOX]
void [!output DIALOG_CLASS]::OnAbout()
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
}
[!endif]


//[!output PUIS_SROPTIONS_DIAlOGPOSITION]
//[!output HELPSTYLE_WINHELP]
//[!output PUIS_SROPTIONS_COMMANDUSAGE]

[!if HELPSTYLE_WINHELP && PUIS_SROPTIONS_COMMANDUSAGE]
void [!output DIALOG_CLASS]::OnDestroy()
{
[!if HELPSTYLE_WINHELP]
	WinHelp(0L, HELP_QUIT);
[!endif]
[!if PUIS_SROPTIONS_COMMANDUSAGE]
[!if VERBOSE]
	//
	// Save command usage statistics
	//
[!endif]
	CWinApp * pApp = ::AfxGetApp();
	ASSERT( pApp != NULL );
	ASSERT( pApp->m_pszRegistryKey != NULL );
	ASSERT( pApp->m_pszRegistryKey[0] != _T('\0') );
	ASSERT( pApp->m_pszProfileName != NULL );
	ASSERT( pApp->m_pszProfileName[0] != _T('\0') );
	g_CmdManager->SerializeState(
		__PROF_UIS_PROJECT_CMD_PROFILE_NAME,
		pApp->m_pszRegistryKey,
		pApp->m_pszProfileName,
		true
		);

[!if VERBOSE]
	//
	// Detach this window from Prof-UIS command manager profile
	//
[!endif]
	g_CmdManager->ProfileWndRemove( GetSafeHwnd() );
[!endif]

	CExtNCW < CExtResizableDialog >::OnDestroy();

}
[!endif]

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void [!output DIALOG_CLASS]::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
                CExtNCW < CExtResizableDialog >::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR [!output DIALOG_CLASS]::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}
[!if AUTOMATION]

// Automation servers should not exit when a user closes the UI
//  if a controller still holds on to one of its objects.  These
//  message handlers make sure that if the proxy is still in use,
//  then the UI is hidden but the dialog remains around if it
//  is dismissed.

void [!output DIALOG_CLASS]::OnClose() 
{
	if (CanExit())
		CExtNCW < CExtResizableDialog >::OnClose();
}

void [!output DIALOG_CLASS]::OnOK() 
{
	if (CanExit())
		CExtNCW < CExtResizableDialog >::OnOK();
}

void [!output DIALOG_CLASS]::OnCancel() 
{
	if (CanExit())
		CExtNCW < CExtResizableDialog >::OnCancel();
}

BOOL [!output DIALOG_CLASS]::CanExit()
{
	// If the proxy object is still around, then the automation
	//  controller is still holding on to this application.  Leave
	//  the dialog around, but hide its UI.
	if (m_pAutoProxy != NULL)
	{
		ShowWindow(SW_HIDE);
		return FALSE;
	}

	return TRUE;
}
[!endif]

[!if HTML_DIALOG]
HRESULT [!output DIALOG_CLASS]::OnButtonOK(IHTMLElement* /*pElement*/)
{
	OnOK();
	return S_OK;
}

HRESULT [!output DIALOG_CLASS]::OnButtonCancel(IHTMLElement* /*pElement*/)
{
	OnCancel();
	return S_OK;
}
[!if CONTEXT_HELP]

HRESULT [!output DIALOG_CLASS]::OnButtonHelp(IHTMLElement* /*pElement*/)
{
	OnHelp();
	return S_OK;
}
[!endif]
[!endif]