// [!output APP_IMPL] : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "[!output APP_HEADER]"
#include "[!output DIALOG_HEADER]"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// [!output APP_CLASS]

BEGIN_MESSAGE_MAP([!output APP_CLASS], [!output APP_BASE_CLASS])
	ON_COMMAND(ID_HELP, &CWinApp::OnHelp)
END_MESSAGE_MAP()


// [!output APP_CLASS] construction

[!output APP_CLASS]::[!output APP_CLASS]()
{
[!if CONTEXT_HELP && HELPSTYLE_HTML]
	EnableHtmlHelp();

[!endif]
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only [!output APP_CLASS] object

[!output APP_CLASS] theApp;

/////////////////////////////////////////////////////////////////////////////
// Prof-UIS advanced options

void [!output APP_CLASS]::SetupUiAdvancedOptions()
{
[!if VERBOSE]
	//
	// Prof-UIS command manager profile
	//
[!endif]
	VERIFY(
		g_CmdManager->ProfileSetup(
			__PROF_UIS_PROJECT_CMD_PROFILE_NAME
			)
		);

[!if VERBOSE]
	//
	// General UI look
	//
[!endif]
	g_PaintManager.InstallPaintManager(
		RUNTIME_CLASS( [!output PUIS_APPSTYLE] )
		//RUNTIME_CLASS( CExtPaintManager )
		//RUNTIME_CLASS( CExtPaintManagerXP )
		//RUNTIME_CLASS( CExtPaintManagerOffice2003 )
		//RUNTIME_CLASS( CExtPaintManagerOffice2003NoThemes )
		//RUNTIME_CLASS( CExtPaintManagerStudio2005 )
		//RUNTIME_CLASS( CExtPaintManagerNativeXP )
		//RUNTIME_CLASS( CExtPaintManagerOffice2007_R1 )
		//RUNTIME_CLASS( CExtPaintManagerOffice2007_R2_LunaBlue )
		//RUNTIME_CLASS( CExtPaintManagerOffice2007_R2_Obsidian )
       	);

[!if VERBOSE]
	//
	// Popup menu option: Display menu shadows
	//
[!endif]
[!if PUIS_DISPLAYSHADOW]
	CExtPopupMenuWnd::g_bMenuWithShadows = true;
[!else]
	CExtPopupMenuWnd::g_bMenuWithShadows = false;
[!endif]      

[!if VERBOSE]
	//
	// Popup menu option: Display menu cool tips
	//
[!endif]
[!if PUIS_DISPLAYCOLORTIPS]
	CExtPopupMenuWnd::g_bMenuShowCoolTips = true;
[!else]
	CExtPopupMenuWnd::g_bMenuShowCoolTips = false;
[!endif]

[!if VERBOSE]
	//
	// Popup menu option: Initially hide rarely used items (RUI)
	//
[!endif]
[!if PUIS_INITIALLYHIDERUI]
	CExtPopupMenuWnd::g_bMenuExpanding = true;
[!else]
	CExtPopupMenuWnd::g_bMenuExpanding = false;
[!endif]

[!if VERBOSE]
	//
	// Popup menu option: Display RUI in different style
	//
[!endif]

[!if PUIS_DISPlAYDIFSTYLERUI]
	CExtPopupMenuWnd::g_bMenuHighlightRarely = true;
[!else]
	CExtPopupMenuWnd::g_bMenuHighlightRarely = false;
[!endif]

[!if VERBOSE]
	//
	// Popup menu option: Animate when expanding RUI (like Office XP)
	//
[!endif]      
[!if PUIS_ANIMATEWHENEXPANDRUI]
	CExtPopupMenuWnd::g_bMenuExpandAnimation = true;
[!else]
	CExtPopupMenuWnd::g_bMenuExpandAnimation = false;
[!endif]

[!if VERBOSE]
	//
	// Popup menu option: Align to desktop work area (false - to screen area)
	//
[!endif]
[!if PUIS_ALIGNTODESKTOP]
	CExtPopupMenuWnd::g_bUseDesktopWorkArea = true;
[!else]
	CExtPopupMenuWnd::g_bUseDesktopWorkArea = false;
[!endif]

[!if VERBOSE]
	//
	// Popup menu option: Popup menu animation effect (when displaying)
[!endif]
	CExtPopupMenuWnd::g_DefAnimationType =
		CExtPopupMenuWnd::[!output PUIS_ANIMATIONEFFECT];
		//$$__PROFUISAPPWIZ_KEY_MENU_ANIM_DISPMS$$

}



[!if AUTOMATION]
const GUID CDECL BASED_CODE _tlid =
		[!output LIBID_STATIC_CONST_GUID_FORMAT];
const WORD _wVerMajor = 1;
const WORD _wVerMinor = 0;

[!endif]

// [!output APP_CLASS] initialization

BOOL [!output APP_CLASS]::InitInstance()
{
[!if VERBOSE]
	//
	// Prof-UIS advanced options
        //
[!endif]
	SetupUiAdvancedOptions();

[!if MANIFEST]
	// InitCommonControls() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	InitCommonControls();

[!endif]
	[!output APP_BASE_CLASS]::InitInstance();

[!if SOCKETS]
	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}

[!endif]
[!if AUTOMATION || ACCESSIBILITY]
	// Initialize OLE libraries
	if (!AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}

[!endif]
[!if ACTIVEX_CONTROLS]
	AfxEnableControlContainer();

[!endif]

	SetRegistryKey( _T("[!output PUIS_REGISTRYKEY]") ); //$$__PROFUISAPPWIZ_KEY_APP_REG_KEY$$
	ASSERT( m_pszRegistryKey != NULL );

[!if VERBOSE]
	if( m_pszProfileName != NULL )
		free( (void*)m_pszProfileName );
[!endif]
	m_pszProfileName =
		_tcsdup( _T("[!output PUIS_PROFILENAME]") ); //$$__PROFUISAPPWIZ_KEY_APP_PROFILE_NAME$$
	ASSERT( m_pszProfileName != NULL );


[!if AUTOMATION]
	// Parse command line for automation or reg/unreg switches.
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// App was launched with /Embedding or /Automation switch.
	// Run app as automation server.
	if (cmdInfo.m_bRunEmbedded || cmdInfo.m_bRunAutomated)
	{
		// Register class factories via CoRegisterClassObject().
		COleTemplateServer::RegisterAll();
	}
	// App was launched with /Unregserver or /Unregister switch.  Remove
	// entries from the registry.
	else if (cmdInfo.m_nShellCommand == CCommandLineInfo::AppUnregister)
	{
		COleObjectFactory::UpdateRegistryAll(FALSE);
		AfxOleUnregisterTypeLib(_tlid, _wVerMajor, _wVerMinor);
		return FALSE;
	}
	// App was launched standalone or with other switches (e.g. /Register
	// or /Regserver).  Update registry entries, including typelibrary.
	else
	{
		COleObjectFactory::UpdateRegistryAll();
		AfxOleRegisterTypeLib(AfxGetInstanceHandle(), _tlid);
		if (cmdInfo.m_nShellCommand == CCommandLineInfo::AppRegister)
			return FALSE;
	}
[!endif]

	[!output DIALOG_CLASS] dlg;
	m_pMainWnd = &dlg;
	INT_PTR nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}
