// [!output MAIN_FRAME_IMPL] : implementation of the [!output MAIN_FRAME_CLASS] class
//

#include "stdafx.h"
#include "[!output APP_HEADER]"

#include "[!output MAIN_FRAME_HEADER]"
[!if PROJECT_STYLE_EXPLORER]
[!if APP_TYPE_SDI || APP_TYPE_MTLD]
#include "[!output TREE_VIEW_HEADER]"
#include "[!output VIEW_HEADER]"
[!endif]
[!endif]

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// [!output MAIN_FRAME_CLASS]

[!if APP_TYPE_MDI || !DOCVIEW]
IMPLEMENT_DYNAMIC([!output MAIN_FRAME_CLASS], [!output MAIN_FRAME_BASE_CLASS])
[!else]
IMPLEMENT_DYNCREATE([!output MAIN_FRAME_CLASS], [!output MAIN_FRAME_BASE_CLASS])
[!endif]

BEGIN_MESSAGE_MAP([!output MAIN_FRAME_CLASS], [!output MAIN_FRAME_BASE_CLASS])
[!if DOCKING_TOOLBAR || STATUS_BAR]
	ON_WM_CREATE()
[!else]
[!if APP_TYPE_SDI && !DOCVIEW]
	ON_WM_CREATE()
[!endif]
[!endif]
[!if APP_TYPE_SDI]
[!if !DOCVIEW]
	ON_WM_SETFOCUS()
[!endif] 
[!endif] 
[!if APP_TYPE_MTLD]
	ON_COMMAND(ID_FILE_CLOSE, &[!output MAIN_FRAME_CLASS]::OnFileClose)
[!if !DOCVIEW]
	ON_WM_CLOSE()
[!endif]
[!endif] 
[!if CONTEXT_HELP]
	// Global help commands
	ON_COMMAND(ID_HELP_FINDER, &[!output MAIN_FRAME_BASE_CLASS]::OnHelpFinder)
	ON_COMMAND(ID_HELP, &[!output MAIN_FRAME_BASE_CLASS]::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, &[!output MAIN_FRAME_BASE_CLASS]::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, &[!output MAIN_FRAME_BASE_CLASS]::OnHelpFinder)
[!endif]
[!if PROJECT_STYLE_EXPLORER]
[!if APP_TYPE_SDI || APP_TYPE_MTLD]
[!if LIST_VIEW]
	ON_UPDATE_COMMAND_UI_RANGE(AFX_ID_VIEW_MINIMUM, AFX_ID_VIEW_MAXIMUM, &[!output MAIN_FRAME_CLASS]::OnUpdateViewStyles)
	ON_COMMAND_RANGE(AFX_ID_VIEW_MINIMUM, AFX_ID_VIEW_MAXIMUM, &[!output MAIN_FRAME_CLASS]::OnViewStyle)
[!endif]
[!endif]
[!endif]

[!if PUIS_USEMENUBAR]
	ON_COMMAND_EX(ID_VIEW_MENUBAR, OnBarCheck )
	ON_UPDATE_COMMAND_UI(ID_VIEW_MENUBAR, OnUpdateControlBarMenu)
[!endif]
[!if PUIS_BARWITHOUTCHILDWINDOW]
	ON_COMMAND_EX(ID_VIEW_RESIZABLEBAR_EMPTY, OnBarCheck )
	ON_UPDATE_COMMAND_UI(ID_VIEW_RESIZABLEBAR_EMPTY, OnUpdateControlBarMenu)
[!endif]
[!if PUIS_BARWITHTREECONTROL]
	ON_COMMAND_EX(ID_VIEW_RESIZABLEBAR_TREE, OnBarCheck )
	ON_UPDATE_COMMAND_UI(ID_VIEW_RESIZABLEBAR_TREE, OnUpdateControlBarMenu)
[!endif]
[!if PUIS_BARWITHEDITCONTROL]
	ON_COMMAND_EX(ID_VIEW_RESIZABLEBAR_EDIT, OnBarCheck )
	ON_UPDATE_COMMAND_UI(ID_VIEW_RESIZABLEBAR_EDIT, OnUpdateControlBarMenu)
[!endif]
[!if PUIS_BARWITHCOlORPICKERCONTROL]
	ON_COMMAND_EX(ID_VIEW_RESIZABLEBAR_CP, OnBarCheck )
	ON_UPDATE_COMMAND_UI(ID_VIEW_RESIZABLEBAR_CP, OnUpdateControlBarMenu)
[!endif]
[!if PUIS_BARWITHRESIZEABLEDIALOG]
	ON_COMMAND_EX(ID_VIEW_RESIZABLEBAR_DLG, OnBarCheck )
	ON_UPDATE_COMMAND_UI(ID_VIEW_RESIZABLEBAR_DLG, OnUpdateControlBarMenu)
[!endif]

END_MESSAGE_MAP()
[!if STATUS_BAR]

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
[!if DO_KANA]
	ID_INDICATOR_KANA,
[!endif]
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};
[!endif]


// [!output MAIN_FRAME_CLASS] construction/destruction

[!output MAIN_FRAME_CLASS]::[!output MAIN_FRAME_CLASS]()
{
[!if PUIS_SROPTIONS_MAINFRAMEPOSITION]
	::memset( &m_dataFrameWP, 0, sizeof(WINDOWPLACEMENT) );
	m_dataFrameWP.showCmd = SW_HIDE;
[!endif]

[!if ACCESSIBILITY]
	EnableActiveAccessibility();
[!endif]
	// TODO: add member initialization code here
}

[!output MAIN_FRAME_CLASS]::~[!output MAIN_FRAME_CLASS]()
{
}

[!if DOCKING_TOOLBAR || STATUS_BAR]

int [!output MAIN_FRAME_CLASS]::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
CWinApp * pApp = ::AfxGetApp();
	ASSERT( pApp != NULL );
	ASSERT( pApp->m_pszRegistryKey != NULL );
	ASSERT( pApp->m_pszRegistryKey[0] != _T('\0') );
	ASSERT( pApp->m_pszProfileName != NULL );
	ASSERT( pApp->m_pszProfileName[0] != _T('\0') );
	pApp;



	if (CExtNCW < [!output MAIN_FRAME_BASE_CLASS] >::OnCreate(lpCreateStruct) == -1)
		return -1;


	VERIFY(
		g_CmdManager->ProfileWndAdd(
			__PROF_UIS_PROJECT_CMD_PROFILE_NAME,
			GetSafeHwnd()
			)
		);
	VERIFY(
		g_CmdManager->UpdateFromMenu(
			__PROF_UIS_PROJECT_CMD_PROFILE_NAME,
			IDR_MAINFRAME
			)
		);
[!if APP_TYPE_MDI]
	VERIFY(
		g_CmdManager->UpdateFromMenu(
			__PROF_UIS_PROJECT_CMD_PROFILE_NAME,
			IDR_MAINFRAME
			)
		);
	VERIFY(
		g_CmdManager->UpdateFromMenu(
			__PROF_UIS_PROJECT_CMD_PROFILE_NAME,
			IDR_[!output SAFE_DOC_TYPE_NAME]TYPE
			)
			//IDR_$$DOC$$TYPE
		);
	
[!endif] //PROJTYPE_MDI

[!if APP_TYPE_SDI]
[!if !DOCVIEW]
	// create a view to occupy the client area of the frame
	if (!m_wndView.Create(NULL, NULL, AFX_WS_DEFAULT_VIEW,
		CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL))
	{
		TRACE0("Failed to create view window\n");
		return -1;
	}
[!endif] 
[!endif]

[!if PUIS_USEMENUBAR]
[!if APP_TYPE_MDI]
[!if PUIS_SUPPORTFORMDILIST]
	m_wndMenuBar.SetMdiWindowPopupName( _T("Window") );
[!endif]
[!endif] //PROJTYPE_MDI
	if(	!m_wndMenuBar.Create(
			NULL, // _T("Menu Bar"),
			this,
			ID_VIEW_MENUBAR,
			WS_CHILD|WS_VISIBLE
				|CBRS_TOP|CBRS_TOOLTIPS|CBRS_GRIPPER
				|CBRS_TOOLTIPS
				|CBRS_FLYBY
				|CBRS_SIZE_DYNAMIC
[!if PUIS_HIDETOOLBARMENUBAR]
				|CBRS_HIDE_INPLACE
[!endif]
				)
		)
    {
        TRACE0("Failed to create menubar\n");
        return -1;      // failed to create
    }
[!endif]


[!if DOCKING_TOOLBAR]
	
[!if TOOLBAR_STYLE_REBAR]
	if (!m_wndToolBar.CreateEx(this) ||
[!else]
	if(	!m_wndToolBar.Create(
			NULL, // _T("Main Toolbar"),
			this,
			AFX_IDW_TOOLBAR,
			WS_CHILD | WS_VISIBLE | CBRS_TOP | CBRS_GRIPPER | CBRS_FLYBY | CBRS_SIZE_DYNAMIC
	[!if __PROFUISAPPWIZ_KEY_DOCK_ADV_OPT]
			| CBRS_TOOLTIPS
	[!endif]
	[!if PUIS_HIDETOOLBARMENUBAR]
			| CBRS_HIDE_INPLACE
	[!endif]
		) ||
[!endif]
		!m_wndToolBar.LoadToolBar( IDR_MAINFRAME )
		)
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
[!if TOOLBAR_STYLE_REBAR]
[!if CONTAINER || CONTAINER_SERVER]
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() & ~CBRS_HIDE_INPLACE);
[!endif]
	if (!m_wndDlgBar.Create(this, IDR_MAINFRAME, 
		CBRS_ALIGN_TOP, AFX_IDW_DIALOGBAR))
	{
		TRACE0("Failed to create dialogbar\n");
		return -1;		// fail to create
	}

	if (!m_wndReBar.Create(this) ||
		!m_wndReBar.AddBar(&m_wndToolBar) ||
		!m_wndReBar.AddBar(&m_wndDlgBar))
	{
		TRACE0("Failed to create rebar\n");
		return -1;      // fail to create
	}
[!if CONTAINER || CONTAINER_SERVER]
	m_wndReBar.SetBarStyle(m_wndReBar.GetBarStyle() & ~CBRS_HIDE_INPLACE);
[!endif]
[!endif]
[!endif]
[!if STATUS_BAR]

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}
[!endif]

[!if PUIS_BARWITHOUTCHILDWINDOW]
	m_wndResizableBarEmpty.SetInitDesiredSizeVertical(
		CSize( 200, 400 )
		);
	m_wndResizableBarEmpty.SetInitDesiredSizeHorizontal(
		CSize( 400, 200 )
		);
	if(	!m_wndResizableBarEmpty.Create(
			NULL, // _T("Optional control bar caption"),
			this,
			ID_VIEW_RESIZABLEBAR_EMPTY,
			WS_CHILD|WS_VISIBLE|CBRS_TOP|CBRS_GRIPPER
[!if __PROFUISAPPWIZ_KEY_DOCK_ADV_OPT]
				|CBRS_TOOLTIPS
[!endif]
				|CBRS_FLYBY
				|CBRS_SIZE_DYNAMIC
[!if PUIS_HIDERESIZABLEDIALOGFOROLE]
				|CBRS_HIDE_INPLACE
[!endif]
			)
		)
	{
		TRACE0("Failed to create m_wndResizableBarEmpty\n");
		return -1;		// fail to create
	}
[!endif]
[!if PUIS_BARWITHTREECONTROL]//__PROFUISAPPWIZ_KEY_RCB2

	m_wndResizableBarTree.SetInitDesiredSizeVertical(
		CSize( 200, 400 )
		);
	m_wndResizableBarTree.SetInitDesiredSizeHorizontal(
		CSize( 400, 200 )
		);
	if(	!m_wndResizableBarTree.Create(
			NULL, // _T("Optional control bar caption"),
			this,
			ID_VIEW_RESIZABLEBAR_TREE,
			WS_CHILD|WS_VISIBLE|CBRS_TOP|CBRS_GRIPPER
[!if __PROFUISAPPWIZ_KEY_DOCK_ADV_OPT]
				|CBRS_TOOLTIPS
[!endif]
				|CBRS_FLYBY
				|CBRS_SIZE_DYNAMIC
[!if PUIS_HIDERESIZABLEDIALOGFOROLE]
				|CBRS_HIDE_INPLACE
[!endif]
			)
		)
	{
		TRACE0("Failed to create m_wndResizableBarTree\n");
		return -1;		// fail to create
	}
	if( !m_wndDockedCtrlTree.Create(
			WS_CHILD|WS_VISIBLE|WS_VSCROLL|WS_HSCROLL
			|TVS_HASBUTTONS|TVS_HASLINES|TVS_LINESATROOT
			|TVS_INFOTIP|TVS_DISABLEDRAGDROP
			|TVS_SINGLEEXPAND|TVS_SHOWSELALWAYS
			,
			CRect(0,0,0,0),
			&m_wndResizableBarTree,
			m_wndResizableBarTree.GetDlgCtrlID()
			)
		)
	{
		TRACE0("Failed to create m_wndDockedCtrlEdit\n");
		return -1;		// fail to create
	}
	m_wndDockedCtrlTree.SetFont(
		CFont::FromHandle(
			(HFONT)::GetStockObject(DEFAULT_GUI_FONT)
			)
		);
	for( int nTreeIdx0=0; nTreeIdx0<10; nTreeIdx0++ )
	{
		CString sTreeItemText;
		sTreeItemText.Format( _T("Item 1-%d"), nTreeIdx0+1 );
		HTREEITEM htiAtLevel0 =
			m_wndDockedCtrlTree.InsertItem(
			LPCTSTR(sTreeItemText)
			);
		ASSERT( htiAtLevel0 != NULL );
		for( int nTreeIdx1=0; nTreeIdx1<5; nTreeIdx1++ )
		{
			sTreeItemText.Format( _T("Item 2-%d"), nTreeIdx1+1 );
			HTREEITEM htiAtLevel1 =
				m_wndDockedCtrlTree.InsertItem(
					LPCTSTR(sTreeItemText),
					htiAtLevel0
					);
			ASSERT( htiAtLevel1 != NULL );
			for( int nTreeIdx2=0; nTreeIdx2<3; nTreeIdx2++ )
			{
				sTreeItemText.Format( _T("Item 3-%d"), nTreeIdx2+1 );
				HTREEITEM htiAtLevel2 =
					m_wndDockedCtrlTree.InsertItem(
						LPCTSTR(sTreeItemText),
						htiAtLevel1
						);
				ASSERT( htiAtLevel2 != NULL );
				htiAtLevel2;
			} // for( int nTreeIdx2=0; nTreeIdx2<5; nTreeIdx2++ )
		} // for( int nTreeIdx1=0; nTreeIdx1<5; nTreeIdx1++ )
	} // for( int nTreeIdx0=0; nTreeIdx0<10; nTreeIdx0++ )
[!endif]
[!if PUIS_BARWITHEDITCONTROL]//__PROFUISAPPWIZ_KEY_RCB3

	m_wndResizableBarEdit.SetInitDesiredSizeVertical(
		CSize( 200, 400 )
		);
	m_wndResizableBarEdit.SetInitDesiredSizeHorizontal(
		CSize( 400, 200 )
		);
	if(	!m_wndResizableBarEdit.Create(
			NULL, // _T("Optional control bar caption"),
			this,
			ID_VIEW_RESIZABLEBAR_EDIT,
			WS_CHILD|WS_VISIBLE|CBRS_TOP|CBRS_GRIPPER
[!if __PROFUISAPPWIZ_KEY_DOCK_ADV_OPT]
				|CBRS_TOOLTIPS
[!endif]
				|CBRS_FLYBY
				|CBRS_SIZE_DYNAMIC
[!if PUIS_HIDERESIZABLEDIALOGFOROLE]
				|CBRS_HIDE_INPLACE
[!endif]
			)
		)
	{
		TRACE0("Failed to create m_wndResizableBarEdit\n");
		return -1;		// fail to create
	}
	if( !m_wndDockedCtrlEdit.Create(
			WS_CHILD|WS_VISIBLE
				|ES_MULTILINE|ES_LEFT
				|ES_NOHIDESEL|ES_WANTRETURN
				,
			CRect(0,0,0,0),
			&m_wndResizableBarEdit,
			m_wndResizableBarEdit.GetDlgCtrlID()
			)
		)
	{
		TRACE0("Failed to create m_wndDockedCtrlEdit\n");
		return -1;		// fail to create
	}
	m_wndDockedCtrlEdit.SetFont(
		CFont::FromHandle(
			(HFONT)::GetStockObject(DEFAULT_GUI_FONT)
			)
		);
	m_wndDockedCtrlEdit.SetWindowText(
		_T("    Edit control\r\n")
		_T("    inside resizable control bar")
		);
[!endif]
[!if PUIS_BARWITHCOlORPICKERCONTROL]

	m_wndResizableBarCP.SetInitDesiredSizeVertical(
		CSize( 200, 400 )
		);
	m_wndResizableBarCP.SetInitDesiredSizeHorizontal(
		CSize( 400, 200 )
		);
	if(	!m_wndResizableBarCP.Create(
			NULL, // _T("Optional control bar caption"),
			this,
			ID_VIEW_RESIZABLEBAR_CP,
			WS_CHILD|WS_VISIBLE|CBRS_TOP|CBRS_GRIPPER
[!if __PROFUISAPPWIZ_KEY_DOCK_ADV_OPT]
				|CBRS_TOOLTIPS
[!endif]
				|CBRS_FLYBY
				|CBRS_SIZE_DYNAMIC
[!if PUIS_HIDERESIZABLEDIALOGFOROLE]
				|CBRS_HIDE_INPLACE
[!endif]
			)
		)
	{
		TRACE0("Failed to create m_wndResizableBarCP\n");
		return -1;		// fail to create
	}
	if( !m_wndDockedCtrlCP.Create(
			_T("BUTTON"),
			_T(""),
			WS_CHILD|WS_VISIBLE,
			CRect(0,0,0,0),
			&m_wndResizableBarCP,
			m_wndResizableBarCP.GetDlgCtrlID()
			)
		)
	{
		TRACE0("Failed to create m_wndDockedCtrlCP\n");
		return -1;		// fail to create
	}
[!endif]
[!if PUIS_BARWITHRESIZEABLEDIALOG]

	m_wndResizableBarDlg.SetInitDesiredSizeVertical(
		CSize( 200, 400 )
		);
	m_wndResizableBarDlg.SetInitDesiredSizeHorizontal(
		CSize( 400, 200 )
		);
	if(	!m_wndResizableBarDlg.Create(
			NULL, // _T("Optional control bar caption"),
			this,
			ID_VIEW_RESIZABLEBAR_DLG,
			WS_CHILD|WS_VISIBLE|CBRS_TOP|CBRS_GRIPPER
[!if __PROFUISAPPWIZ_KEY_DOCK_ADV_OPT]
				|CBRS_TOOLTIPS
[!endif]
				|CBRS_FLYBY
				|CBRS_SIZE_DYNAMIC
[!if PUIS_HIDERESIZABLEDIALOGFOROLE]
				|CBRS_HIDE_INPLACE
[!endif]
			)
		)
	{
		TRACE0("Failed to create m_wndResizableBarDlg\n");
		return -1;		// fail to create
	}
	if( !m_wndDockedResizableDialog.Create(
			IDD_DIALOG_FOR_RESIZABLE_BAR,
			&m_wndResizableBarDlg
			)
		)
	{
		TRACE0("Failed to create m_wndResizableBarDlg\n");
		return -1;		// fail to create
	}
	m_wndDockedResizableDialog.ShowSizeGrip( FALSE );
	m_wndDockedResizableDialog.AddAnchor(
		IDC_EDIT_IN_RESIZABLE_FORM,
		__RDA_LT,
		__RDA_RT
		);
	VERIFY(
		m_wndEditInDockedDlg.SubclassDlgItem(
			IDC_EDIT_IN_RESIZABLE_FORM,
			&m_wndDockedResizableDialog
			)
		);
[!endif]


	// TODO: Delete these lines if you don't want the dockable entity
[!if PUIS_USEMENUBAR]
	m_wndMenuBar.EnableDocking( CBRS_ALIGN_ANY );
[!endif]
	m_wndToolBar.EnableDocking( CBRS_ALIGN_ANY );
[!if PUIS_BARWITHOUTCHILDWINDOW]
	m_wndResizableBarEmpty.EnableDocking( CBRS_ALIGN_ANY );
[!endif]
[!if PUIS_BARWITHTREECONTROL]
	m_wndResizableBarTree.EnableDocking( CBRS_ALIGN_ANY );
[!endif]
[!if PUIS_BARWITHEDITCONTROL]
	m_wndResizableBarEdit.EnableDocking( CBRS_ALIGN_ANY );
[!endif]
[!if PUIS_BARWITHCOlORPICKERCONTROL]
	m_wndResizableBarCP.EnableDocking( CBRS_ALIGN_ANY );
[!endif]
[!if PUIS_BARWITHRESIZEABLEDIALOG]
	m_wndResizableBarDlg.EnableDocking( CBRS_ALIGN_ANY );
[!endif]

[!if VERBOSE]
	// Enable control bars in the frame window to be redocable
[!endif] //VERBOSE
	if( !CExtControlBar::FrameEnableDocking(this) )
	{
		ASSERT( FALSE );
		return -1;
	}

[!if PUIS_ENABLEAUTOHIDE]
[!if VERBOSE]
	// Enable autohide feature for resizable control bars
[!endif] //VERBOSE
	if( !CExtControlBar::FrameInjectAutoHideAreas(this) )
	{
		ASSERT( FALSE );
		return -1;
	}
[!endif] 

[!if PUIS_USEMENUBAR]
	DockControlBar( &m_wndMenuBar );
[!endif]
	DockControlBar( &m_wndToolBar );

[!if PUIS_BARWITHOUTCHILDWINDOW]
	m_wndResizableBarEmpty.FloatControlBar( CPoint( 300, 200 ) );
[!endif]
[!if PUIS_BARWITHTREECONTROL]
	m_wndResizableBarTree.DockControlBar(
		AFX_IDW_DOCKBAR_LEFT,
		1, 
		this
		);
[!endif]
[!if PUIS_BARWITHEDITCONTROL]
	m_wndResizableBarEdit.DockControlBar(
		AFX_IDW_DOCKBAR_RIGHT,
		1, 
		this
		);
[!endif]
[!if PUIS_BARWITHCOlORPICKERCONTROL]
	m_wndResizableBarCP.DockControlBar(
		AFX_IDW_DOCKBAR_TOP,
		2, 
		this
		);
[!endif]
[!if PUIS_BARWITHRESIZEABLEDIALOG]
	m_wndResizableBarDlg.DockControlBar(
		AFX_IDW_DOCKBAR_BOTTOM,
		2, 
		this
		);
[!endif]


[!if PUIS_INITIALLISTBASICCOMMAND]
static UINT statBasicCommands[] =
{
[!if APP_TYPE_MDI || DOCVIEW]
	ID_FILE_NEW, 
[!endif] //(PROJTYPE_MDI || !NODOCVIEW)
[!if DOCVIEW]
	ID_FILE_OPEN, 
	ID_FILE_SAVE,
[!endif] //!NODOCVIEW
	ID_APP_EXIT,
	ID_APP_ABOUT,
[!if APP_TYPE_MDI || APP_TYPE_SDI]
[!if DOCVIEW && PRINTING]
// PRINT
//	ID_FILE_PRINT,
//	ID_FILE_PRINT_SETUP, 
[!endif]
[!endif]
	ID_EDIT_COPY, 
	ID_EDIT_CUT, 
	ID_EDIT_PASTE, 
	ID_EDIT_UNDO, 
[!if !TOOLBAR_NONE]
	ID_VIEW_TOOLBAR, 
[!endif] //TOOLBAR
[!if PUIS_BARWITHOUTCHILDWINDOW]
	ID_VIEW_RESIZABLEBAR_EMPTY,
[!endif]
[!if PUIS_BARWITHTREECONTROL]
	ID_VIEW_RESIZABLEBAR_TREE,
[!endif]
[!if PUIS_BARWITHEDITCONTROL]
	ID_VIEW_RESIZABLEBAR_EDIT,
[!endif]
[!if PUIS_BARWITHCOlORPICKERCONTROL]
	ID_VIEW_RESIZABLEBAR_CP,
[!endif]
[!if PUIS_BARWITHRESIZEABLEDIALOG]
	ID_VIEW_RESIZABLEBAR_DLG,
[!endif]
[!if APP_TYPE_MDI]
	ID_WINDOW_TILE_HORZ,
[!endif]      
[!if ODBC_RECORD_VIEW || OLEDB_RECORD_VIEW]
	ID_RECORD_NEXT,
	ID_RECORD_LAST,
[!endif] //(CRecordView || CDaoRecordView || COleDBRecordView)
[!if CONTEXT_HELP]
	ID_HELP_FINDER, 
[!endif] //HELP
	0 // end of commands list
}; // statBasicCommands array

	VERIFY(
		g_CmdManager->SetBasicCommands(
			__PROF_UIS_PROJECT_CMD_PROFILE_NAME,
			statBasicCommands
			)
		);

[!endif]



[!if PUIS_USETABWINDOWFROMDI != 0]
	if( !m_wndMdiTabs.Create(
			this, 
			CRect( 0, 0, 0, 0 ),
			UINT( IDC_STATIC ),
			WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS,
			[!output PUIS_TABWINDOWFROMDI]
[!if PUIS_ENABLEHELP]
			|__ETWS_ENABLED_BTN_HELP
[!endif]
[!if PUIS_SHOWHELP]
			|__ETWS_SHOW_BTN_HELP
[!endif]
[!if PUIS_ENABLECLOSE]
			|__ETWS_ENABLED_BTN_CLOSE
[!endif]
[!if PUIS_SHOWCLOSE]
			|__ETWS_SHOW_BTN_CLOSE
[!endif]
			)
			//PUIS_TABWINDOWFROMDI - $$__PROFUISAPPWIZ_KEY_ADF_MDITABS$$
		)
	{
		ASSERT( FALSE );
		return -1;
	}
[!endif]
[!if PUIS_SROPTIONS_MTRPOSITION]
	CExtControlBar::ProfileBarStateLoad(
		this,
		pApp->m_pszRegistryKey,
		pApp->m_pszProfileName,
		pApp->m_pszProfileName,
		&m_dataFrameWP
		);

[!endif]
[!if PUIS_SROPTIONS_MTRPOSITION]
	g_CmdManager->SerializeState(
		__PROF_UIS_PROJECT_CMD_PROFILE_NAME,
		pApp->m_pszRegistryKey,
		pApp->m_pszProfileName,
		false
		);

[!endif]

	return 0;
}
[!else]
[!if APP_TYPE_SDI && !DOCVIEW]

int [!output MAIN_FRAME_CLASS]::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CExtNCW < [!output MAIN_FRAME_BASE_CLASS] >::OnCreate(lpCreateStruct) == -1)
		return -1;

	// create a view to occupy the client area of the frame
	if (!m_wndView.Create(NULL, NULL, AFX_WS_DEFAULT_VIEW,
		CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL))
	{
		TRACE0("Failed to create view window\n");
		return -1;
	}
	return 0;
}
[!endif]
[!endif]
[!if SPLITTER || PROJECT_STYLE_EXPLORER]
[!if APP_TYPE_SDI || APP_TYPE_MTLD]

BOOL [!output MAIN_FRAME_CLASS]::OnCreateClient(LPCREATESTRUCT /*lpcs*/,
	CCreateContext* pContext)
{
[!if PROJECT_STYLE_EXPLORER]
	// create splitter window
	if (!m_wndSplitter.CreateStatic(this, 1, 2))
		return FALSE;

	if (!m_wndSplitter.CreateView(0, 0, RUNTIME_CLASS([!output TREE_VIEW_CLASS]), CSize(100, 100), pContext) ||
		!m_wndSplitter.CreateView(0, 1, RUNTIME_CLASS([!output VIEW_CLASS]), CSize(100, 100), pContext))
	{
		m_wndSplitter.DestroyWindow();
		return FALSE;
	}

	return TRUE;
[!else]
[!if HTML_VIEW || HTML_EDITVIEW]
	return m_wndSplitter.Create(this,
		2, 2,               // TODO: adjust the number of rows, columns
		CSize(10, 10),      // TODO: adjust the minimum pane size
		pContext, WS_CHILD | WS_VISIBLE | SPLS_DYNAMIC_SPLIT);
[!else]
	return m_wndSplitter.Create(this,
		2, 2,               // TODO: adjust the number of rows, columns
		CSize(10, 10),      // TODO: adjust the minimum pane size
		pContext);
[!endif]
[!endif]
}
[!endif]
[!endif]


BOOL [!output MAIN_FRAME_CLASS]::DestroyWindow() 
{
CWinApp * pApp = ::AfxGetApp();
	ASSERT( pApp != NULL );
	ASSERT( pApp->m_pszRegistryKey != NULL );
	ASSERT( pApp->m_pszRegistryKey[0] != _T('\0') );
	ASSERT( pApp->m_pszProfileName != NULL );
	ASSERT( pApp->m_pszProfileName[0] != _T('\0') );
	pApp;

[!if PUIS_SROPTIONS_MTRPOSITION]
	VERIFY(
		CExtControlBar::ProfileBarStateSave(
			this,
			pApp->m_pszRegistryKey,
			pApp->m_pszProfileName,
			pApp->m_pszProfileName,
			&m_dataFrameWP
			)
		);
[!endif]
[!if PUIS_SROPTIONS_COMMANDUSAGE]
	VERIFY(
		g_CmdManager->SerializeState(
			__PROF_UIS_PROJECT_CMD_PROFILE_NAME,
			pApp->m_pszRegistryKey,
			pApp->m_pszProfileName,
			true
			)
		);
[!endif]

	g_CmdManager->ProfileWndRemove( GetSafeHwnd() );
	
	return CExtNCW < [!output MAIN_FRAME_BASE_CLASS] >::DestroyWindow();
}

[!if PUIS_SROPTIONS_MAINFRAMEPOSITION]
void [!output MAIN_FRAME_CLASS]::ActivateFrame(int nCmdShow) 
{
	if( m_dataFrameWP.showCmd != SW_HIDE )
	{
		SetWindowPlacement( &m_dataFrameWP );
		CExtNCW < [!output MAIN_FRAME_BASE_CLASS] >::ActivateFrame( m_dataFrameWP.showCmd );
		m_dataFrameWP.showCmd = SW_HIDE;
		return;
	}
	CExtNCW < [!output MAIN_FRAME_BASE_CLASS] >::ActivateFrame(nCmdShow);
}
[!endif]


BOOL [!output MAIN_FRAME_CLASS]::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CExtNCW < [!output MAIN_FRAME_BASE_CLASS] >::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

[!if !MAIN_FRAME_DEFAULT_STYLES]
	cs.style = WS_OVERLAPPED | WS_CAPTION | FWS_ADDTOTITLE
		[!output MAIN_FRAME_STYLE_FLAGS];

[!endif]
[!if APP_TYPE_SDI]
[!if !DOCVIEW]
	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = AfxRegisterWndClass(0);
[!endif] 
[!endif]
	return TRUE;
}


// [!output MAIN_FRAME_CLASS] diagnostics

#ifdef _DEBUG
void [!output MAIN_FRAME_CLASS]::AssertValid() const
{
	CExtNCW < [!output MAIN_FRAME_BASE_CLASS] >::AssertValid();
}

void [!output MAIN_FRAME_CLASS]::Dump(CDumpContext& dc) const
{
	CExtNCW < [!output MAIN_FRAME_BASE_CLASS] >::Dump(dc);
}

#endif //_DEBUG


// [!output MAIN_FRAME_CLASS] message handlers

[!if APP_TYPE_SDI]
[!if !DOCVIEW]
void [!output MAIN_FRAME_CLASS]::OnSetFocus(CWnd* /*pOldWnd*/)
{
	// forward focus to the view window
	m_wndView.SetFocus();
}

BOOL [!output MAIN_FRAME_CLASS]::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	// let the view have first crack at the command
	if (m_wndView.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;

	// otherwise, do default handling
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}
[!endif] 
[!endif]

[!if APP_TYPE_SDI || APP_TYPE_MTLD]
[!if PROJECT_STYLE_EXPLORER]
[!if LIST_VIEW]
[!output VIEW_CLASS]* [!output MAIN_FRAME_CLASS]::GetRightPane()
{
	CWnd* pWnd = m_wndSplitter.GetPane(0, 1);
	[!output VIEW_CLASS]* pView = DYNAMIC_DOWNCAST([!output VIEW_CLASS], pWnd);
	return pView;
}

void [!output MAIN_FRAME_CLASS]::OnUpdateViewStyles(CCmdUI* pCmdUI)
{
	if (!pCmdUI)
		return;

	// TODO: customize or extend this code to handle choices on the View menu

	[!output VIEW_CLASS]* pView = GetRightPane(); 

	// if the right-hand pane hasn't been created or isn't a view,
	// disable commands in our range

	if (pView == NULL)
		pCmdUI->Enable(FALSE);
	else
	{
		DWORD dwStyle = pView->GetStyle() & LVS_TYPEMASK;

		// if the command is ID_VIEW_LINEUP, only enable command
		// when we're in LVS_ICON or LVS_SMALLICON mode

		if (pCmdUI->m_nID == ID_VIEW_LINEUP)
		{
			if (dwStyle == LVS_ICON || dwStyle == LVS_SMALLICON)
				pCmdUI->Enable();
			else
				pCmdUI->Enable(FALSE);
		}
		else
		{
			// otherwise, use dots to reflect the style of the view
			pCmdUI->Enable();
			BOOL bChecked = FALSE;

			switch (pCmdUI->m_nID)
			{
			case ID_VIEW_DETAILS:
				bChecked = (dwStyle == LVS_REPORT);
				break;

			case ID_VIEW_SMALLICON:
				bChecked = (dwStyle == LVS_SMALLICON);
				break;

			case ID_VIEW_LARGEICON:
				bChecked = (dwStyle == LVS_ICON);
				break;

			case ID_VIEW_LIST:
				bChecked = (dwStyle == LVS_LIST);
				break;

			default:
				bChecked = FALSE;
				break;
			}

			pCmdUI->SetRadio(bChecked ? 1 : 0);
		}
	}
}


void [!output MAIN_FRAME_CLASS]::OnViewStyle(UINT nCommandID)
{
	// TODO: customize or extend this code to handle choices on the View menu
	[!output VIEW_CLASS]* pView = GetRightPane();

	// if the right-hand pane has been created and is a [!output VIEW_CLASS],
	// process the menu commands...
	if (pView != NULL)
	{
		DWORD dwStyle = -1;

		switch (nCommandID)
		{
		case ID_VIEW_LINEUP:
			{
				// ask the list control to snap to grid
				CListCtrl& refListCtrl = pView->GetListCtrl();
				refListCtrl.Arrange(LVA_SNAPTOGRID);
			}
			break;

		// other commands change the style on the list control
		case ID_VIEW_DETAILS:
			dwStyle = LVS_REPORT;
			break;

		case ID_VIEW_SMALLICON:
			dwStyle = LVS_SMALLICON;
			break;

		case ID_VIEW_LARGEICON:
			dwStyle = LVS_ICON;
			break;

		case ID_VIEW_LIST:
			dwStyle = LVS_LIST;
			break;
		}

		// change the style; window will repaint automatically
		if (dwStyle != -1)
			pView->ModifyStyle(LVS_TYPEMASK, dwStyle);
	}
}
[!endif]
[!endif]
[!endif]

[!if APP_TYPE_MTLD]
BOOL [!output MAIN_FRAME_CLASS]::LoadFrame(UINT nIDResource, DWORD dwDefaultStyle, CWnd* pParentWnd, CCreateContext* pContext) 
{
	// base class does the real work

	if (!CFrameWnd::LoadFrame(nIDResource, dwDefaultStyle, pParentWnd, pContext))
	{
		return FALSE;
	}

	CWinApp* pApp = AfxGetApp();
	if (pApp->m_pMainWnd == NULL)
		pApp->m_pMainWnd = this;

	// replace Exit option on File menu with Close for secondary windows
	if (AfxGetApp()->m_pMainWnd != this)
	{
		CMenu *pMenu = GetMenu();
		ASSERT(pMenu);
		pMenu->ModifyMenu(ID_APP_EXIT, MF_BYCOMMAND | MF_STRING, ID_FILE_CLOSE, _T("&Close"));
	}

	return TRUE;
}

void [!output MAIN_FRAME_CLASS]::OnFileClose()
{
   DestroyWindow();
}
[!if !DOCVIEW]

void [!output MAIN_FRAME_CLASS]::OnClose() 
{
	[!output APP_CLASS] *pApp = reinterpret_cast<[!output APP_CLASS]*>(AfxGetApp());
	// main window is being closed so cleanup
	if (pApp->m_pMainWnd == this)
	{
		for (int iCntr=0; iCntr < pApp->m_aryFrames.GetSize(); iCntr++)
		{
			HWND hFrame = pApp->m_aryFrames.GetAt(iCntr);
			if (::IsWindow(hFrame))
				::SendMessage(hFrame, WM_CLOSE, 0, 0);
		}
	}
	CFrameWnd::OnClose();
}
[!endif]
[!endif]


[!if PUIS_USEMENUBAR]
[!if CONTAINER || CONTAINER_SERVER]
[!if RICH_EDIT_VIEW]
LRESULT [!output MAIN_FRAME_CLASS]::OnExtMenuPrepare(WPARAM wParam, LPARAM lParam)
{
[!if APP_TYPE_MDI]
CFrameWnd * pActiveFrame = MDIGetActive();
	if( pActiveFrame == NULL )
		return LRESULT( FALSE );
	ASSERT_VALID( pActiveFrame );
CView * pView = pActiveFrame->GetActiveView();
	if( pView == NULL )
		return LRESULT( FALSE );
	ASSERT_VALID( pView );
[!else] //!PROJTYPE_MDI
CView * pView = GetActiveView();
	if( pView == NULL )
		return LRESULT( FALSE );
	ASSERT_VALID( pView );
[!endif] //!PROJTYPE_MDI
	return
		pView->SendMessage(
			CExtPopupMenuWnd::g_nMsgPrepareMenu,
			wParam,
			lParam
			);
}

[!endif] //!CRichEditView
[!endif] //CONTAINER || CONTAINER_SERVER
BOOL [!output MAIN_FRAME_CLASS]::PreTranslateMessage(MSG* pMsg) 
{
[!if PUIS_USEMENUBAR]
	if( m_wndMenuBar.TranslateMainFrameMessage(pMsg) )
		return TRUE;
[!endif]
	return CExtNCW < [!output MAIN_FRAME_BASE_CLASS] >::PreTranslateMessage(pMsg);
}

[!endif]



void [!output MAIN_FRAME_CLASS]::OnUpdateControlBarMenu(CCmdUI* pCmdUI)
{
	CExtControlBar::DoFrameBarCheckUpdate(
		this,
		pCmdUI,
		false
		);
}

BOOL [!output MAIN_FRAME_CLASS]::OnBarCheck(UINT nID)
{
	return
		CExtControlBar::DoFrameBarCheckCmd(
			this,
			nID,
			false
			);
}
